'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'   ACTvZT[rX TvvO
'   B/vZݒtH[NX
'
'   Copyrights (c) 2004-2011 Advanced Core Technologies, Inc. All rights reserved.
'
'   2005/02/02 Rev.1.02    RIN vZT[rXpƂĒǉ
'   2009/02/09 Rev.2.0.1.0 ISHI [_ΉACAParamΉ
'   2010/09/17 Rev.2.1.1.0 ISHI CalcArea2Ή
'   2011/11/07 Rev.2.3.0.0 ISHI CalcArea3Ή
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

Imports Act.Dcws

''' <summary>
''' B/vZp[^ݒtH[NX
''' </summary>
''' <remarks></remarks>
Partial Public Class AreaForm
    Inherits System.Windows.Forms.Form

    '----------------------------------------------------------------------------------------------
    '	Constants
    '----------------------------------------------------------------------------------------------
#Region "Constants"

    ''' <summary>
    ''' vZ͈͂̍ŏl
    ''' </summary>
    Private Const CalcRangeMin_ As Int32 = 1
    ''' <summary>
    ''' vZ͈͂̍ől
    ''' </summary>
    Private Const CalcRangeMax_ As Int32 = 9999

#End Region

    '----------------------------------------------------------------------------------------------
    '	Private Fields
    '----------------------------------------------------------------------------------------------
#Region "Private Fields"

    ''' <summary>
    ''' CalcAreapp[^
    ''' </summary>
    Private param_ As DCService.CA3Param

#End Region

    '----------------------------------------------------------------------------------------------
    '	Private Methods
    '----------------------------------------------------------------------------------------------
#Region "Private Methods"

    ''' <summary>
    ''' |Sʊ֘ARg[̏ԂύX
    ''' </summary>
    Private Sub ChangePolygonControls()
        If radioMultiPolygon.Checked Then
            ' |S
            labelDonutPolygonLebel.Enabled = True
            comboDonutPolygonLevel.Enabled = True
            labelDonutPolygonLebelDigit.Enabled = True
            checkExpandMidLink.Enabled = False
            checkExpandTerminalLink.Enabled = False
        Else
            ' P|S
            labelDonutPolygonLebel.Enabled = False
            comboDonutPolygonLevel.Enabled = False
            labelDonutPolygonLebelDigit.Enabled = False
            checkExpandMidLink.Enabled = True
            checkExpandTerminalLink.Enabled = True
        End If
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Public Methods
    '----------------------------------------------------------------------------------------------
#Region "Public Methods"

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <param name="param">CalcAreap[^</param>
    ''' <remarks></remarks>
    Public Sub New(ByVal param As SampleMG.DCService.CA3Param)
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

        '   p[^i[
        param_ = param

    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Event Handlers
    '----------------------------------------------------------------------------------------------
#Region "Event Handlers"

    ''' <summary>
    ''' tH[̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub AreaForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '   vZp[^IuWFNg̃f[^UIɐݒ肷
        '   [vZݒ]
        '   vZ@
        If param_.CalcKind = CalcKind.Time Then                                 '   ŒZ
            radioCalcKindTime.Checked = True
        Else                                                                    '   ŒZ
            radioCalcKindDist.Checked = True
        End If

        '   Hgp
        If (param_.Transport And Transport.Highway) <> 0 Then
            checkUseHighway.Checked = True                                      '   Hgp
        Else
            checkUseHighway.Checked = False                                     '   Hsgp
        End If
        '   Sgp
        If (param_.Transport And Transport.Railroad) <> 0 Then
            checkUseRailroad.Checked = True                                     '   Sgp
        Else
            checkUseRailroad.Checked = False                                    '   Ssgp
        End If
        '   q@gp
        If (param_.Transport And Transport.Airway) <> 0 Then
            checkUseAirway.Checked = True                                       '   q@gp
        Else
            checkUseAirway.Checked = False                                      '   q@sgp
        End If
        '   tF[gpƖkCÂݎgp
        If (param_.Transport And Transport.PayRoadFerry) <> 0 Then
            checkUsePayRoadFr.Checked = True                                    '   kCÂ݃tF[gp
            checkUseFerry.Checked = True
        Else
            checkUsePayRoadFr.Checked = False
            If (param_.Transport And Transport.Ferry) <> 0 Then
                checkUseFerry.Checked = True                                    '   tF[gp
            Else
                checkUseFerry.Checked = False                                   '   tF[sgp
            End If
        End If
        '   qDgp
        If (param_.Transport And Transport.Ship) <> 0 Then
            checkUseShip.Checked = True                                         '   qDgp
        Else
            checkUseShip.Checked = False                                        '   qDsgp
        End If

        '   vZ
        If param_.AreaDirection = AreaDirection.OutFlow Then
            radioCalcAreaDirectionOutflow.Checked = True                        '   BvZ
        Else
            radioCalcAreaDirectionInflow.Checked = True                         '   vZ
        End If
        '   vZ & vZ͈
        If param_.AreaKind = AreaKind.Time Then
            radioCalcAreaRimitTime.Checked = True                               '   
            textCalcAreaRange.Text = (param_.AreaRange / 600).ToString()        '   Pʂɕϊ
        Else
            radioCalcAreaRimitDist.Checked = True                               '   
            textCalcAreaRange.Text = (param_.AreaRange / 1000).ToString()       '   kmPʂɕϊ
        End If

        '   [vZʕ\ݒ]
        '   |S\@
        If param_.PolygonKind = PolygonKind.MultiPolygon Then
            radioMultiPolygon.Checked = True                                    '   |S
        Else
            radioSinglePolygon.Checked = True                                   '   P|S
        End If
        '   |Sx
        comboPolygonLevel.Text = param_.PolygonLevel.ToString()
        '   h[ic|Sx
        comboDonutPolygonLevel.Text = param_.DonutPolygonLevel.ToString()

        '  |Sڍאݒ
        '  ԃN
        If (param_.PolygonDetail And Act.Dcws.PolygonDetail.ExpandMiddle) <> 0 Then
            checkExpandMidLink.Checked = True                                   '  ԃNԎgp
        Else
            checkExpandMidLink.Checked = False                                  '  ԃNԕsgp
        End If

        '  [N
        If (param_.PolygonDetail And Act.Dcws.PolygonDetail.ExpandTerminal) <> 0 Then
            checkExpandTerminalLink.Checked = True                              '  [NԎgp
        Else
            checkExpandTerminalLink.Checked = False                             '  [Nԕsgp
        End If

        '   |S\Rg[֘A Enable 
        ChangePolygonControls()

    End Sub

    ''' <summary>
    ''' tH[N[Y
    ''' vZp[^̃f[^XV
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub AreaForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If DialogResult = DialogResult.OK Then
            '   OK{^gpĕ悤ƂĂꍇ

            Dim areaRange As Int32
            '   UI̓͒l̃`FbNs
            If Not Int32.TryParse(textCalcAreaRange.Text, areaRange) Then
                MessageBox.Show(Me, "vZ͈͂̓͒lsȒlłB19999܂ł̐͂ĂB", "x", _
                                MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                e.Cancel = True '   _CAO͕Ȃ
                Exit Sub
            End If
            If (areaRange < CalcRangeMin_) OrElse (areaRange > CalcRangeMax_) Then
                MessageBox.Show(Me, "vZ͈͂̓͒lw͈͊OłB19999܂ł̐͂ĂB", "x", _
                                MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                e.Cancel = True '   _CAO͕Ȃ
                Exit Sub
            End If

            '   UI̐ݒvZp[^IuWFNg̃f[^ɐݒ肷
            '   [vZݒ]
            '   vZ@
            If radioCalcKindTime.Checked Then                                       '   ŒZ
                param_.CalcKind = CalcKind.Time
            Else                                                                    '   ŒZ
                param_.CalcKind = CalcKind.Dist
            End If

            '  AitO
            param_.Transport = 0                                                    '  AitONA
            '   Hgp
            If checkUseHighway.Checked Then
                param_.Transport += Transport.Highway                               '   Hgp
            End If
            '   Sgp
            If checkUseRailroad.Checked Then
                param_.Transport += Transport.Railroad                              '   Sgp
            End If
            '   q@gp
            If checkUseAirway.Checked Then
                param_.Transport += Transport.Airway                                '   q@gp
            End If
            '   tF[AkCÂݎgp
            If checkUsePayRoadFr.Checked And checkUseFerry.Checked Then
                param_.Transport += Transport.PayRoadFerry                          '   kCÂݎgp
            ElseIf checkUseFerry.Checked Then
                param_.Transport += Transport.Ferry                                 '   tF[gp
            End If
            '   qDgp
            If checkUseShip.Checked Then
                param_.Transport += Transport.Ship                                  '   qDgp
            End If

            '   vZ
            If radioCalcAreaDirectionOutflow.Checked Then
                param_.AreaDirection = AreaDirection.OutFlow                        '   BvZ
            Else
                param_.AreaDirection = AreaDirection.InFlow                         '   vZ
            End If
            '   vZ & vZ͈
            If radioCalcAreaRimitTime.Checked Then
                param_.AreaKind = AreaKind.Time                                     '   
                param_.AreaRange = areaRange * 600                                  '   0.1bPʂɕϊ
            Else
                param_.AreaKind = AreaKind.Dist                                     '   
                param_.AreaRange = areaRange * 1000                                 '   [gPʂɕϊ
            End If

            '   [vZʕ\ݒ]
            '   |S\
            If radioMultiPolygon.Checked Then
                param_.PolygonKind = PolygonKind.MultiPolygon                       '   |Sgp
            Else
                param_.PolygonKind = PolygonKind.SinglePolygon                      '   P|Sgp
            End If
            '   |Sx
            param_.PolygonLevel = Int32.Parse(comboPolygonLevel.Text)
            '   h[ic|Sx
            param_.DonutPolygonLevel = Int32.Parse(comboDonutPolygonLevel.Text)

            '  |SڍאݒNA
            param_.PolygonDetail = PolygonDetail.None
            '  ԃN
            If checkExpandMidLink.Enabled AndAlso checkExpandMidLink.Checked Then
                param_.PolygonDetail += PolygonDetail.ExpandMiddle                  '  ԃNԎgp
            End If
            '  [N
            If checkExpandTerminalLink.Enabled AndAlso checkExpandTerminalLink.Checked Then
                param_.PolygonDetail += PolygonDetail.ExpandTerminal                '  [NԎgp
            End If

        End If
    End Sub

    ''' <summary>
    ''' uԁvPʂ̕\ɂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub radioCalcAreaRimitTime_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioCalcAreaRimitTime.CheckedChanged
        labelCalcAreaRangeDigit.Text = ""
    End Sub

    ''' <summary>
    ''' uvPʂ̕\ɂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub radioCalcAreaRimitDist_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioCalcAreaRimitDist.CheckedChanged
        labelCalcAreaRangeDigit.Text = "km"
    End Sub

    ''' <summary>
    ''' tF[gp`FbN{bNX̃`FbNԕύX
    ''' tF[gp̂݁AkCÂ݌Lɂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub checkUseFerry_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkUseFerry.CheckedChanged
        If checkUseFerry.Checked Then
            checkUsePayRoadFr.Enabled = True
        Else
            checkUsePayRoadFr.Enabled = False
            checkUsePayRoadFr.Checked = False
        End If

    End Sub

    ''' <summary>
    ''' |SʂύXꂽƂɊ֘ARg[̏ԂύX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub radioMultiPolygon_CheckedChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioMultiPolygon.CheckedChanged
        ChangePolygonControls()
    End Sub

#End Region

End Class

