﻿'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'   ACT距離計算サービス サンプルプログラム
'   Constantsクラス
'
'   Copyrights (c) 2004-2011 Advanced Core Technologies, Inc. All rights reserved.
'
'  2010/09/16 Rev.2.1.1.0  ISHI    新規作成
'  2010/12/03 Rev.2.1.2.0  ISHI    SSL設定追加
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

''' <summary>
''' 定数クラス
''' </summary>
''' <remarks></remarks>
Public Class Constants

    '----------------------------------------------------------------------------------------------
    '	Supper Mapple Digital レジストリ
    '----------------------------------------------------------------------------------------------
#Region "Supper Mapple Digital レジストリ"

    ''' <summary>
    ''' Supper Mapple Digitalレジストリパス
    ''' </summary>
    Public Const RegKeySmdMain As String = "SOFTWARE\Super Mapple"

    ''' <summary>
    ''' レジストリパス部分文字列(バージョンの下のアプリケーション設定)
    ''' </summary>
    Public Const RegKeySmdSub As String = "\Mapple\App"

    ''' <summary>
    ''' レジストリ値名(サービスパックバージョン)
    ''' </summary>
    Public Const RegValueNameSmdSp As String = "SP"

#End Region

    '----------------------------------------------------------------------------------------------
    '	INIファイル
    '----------------------------------------------------------------------------------------------
#Region "INIファイル"

    ''' <summary>
    ''' 接続先サーバのセクション名
    ''' </summary>
    Public Const SectionNameServer As String = "SERVER"

    ''' <summary>
    ''' 接続先サーバ USERID のキー名
    ''' </summary>
    Public Const KeyNameServerUserID As String = "SERVER_USERID"

    ''' <summary>
    ''' 接続先サーバ USERID のデフォルト値
    ''' </summary>
    Public Const ServerUserIDDefault As String = ""

    ''' <summary>
    ''' 管理サーバ URL のキー名
    ''' </summary>
    Public Const KeyNameDCAdminUrl As String = "DCADMIN_URL"

    ''' <summary>
    ''' 管理サーバ URL のデフォルト値
    ''' </summary>
    Public Const DCAdminUrlDefault As String = "http://distcalc.act-inc.co.jp/DCADMIN/Admin.asmx"

    ''' <summary>
    ''' SSL設定 のキー名
    ''' </summary>
    Public Const SslMode As String = "SSL_MODE"

    ''' <summary>
    ''' SSL設定 のデフォルト値
    ''' </summary>
    Public Const SslModeDefault As Integer = 1

#End Region

End Class
