'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'   ACTvZT[rX TvvO
'   CtH[NX
'
'   Copyrights (c) 2004-2011 Advanced Core Technologies, Inc. All rights reserved.
'
'   2004/09/09 Rev.1.00    TAT  ō쐬
'   2004/12/29 Rev.1.01    RIN  vZT[rXpƂďC
'   2005/02/02 Rev.1.02    RIN  UI̕ύXɔR[h̕ύX
'   2009/02/09 Rev.2.0.1.0 ISHI [_ΉAB^vZAГꊇvZΉ
'   2009/09/17 Rev.2.1.1.0 ISHI MappleGΉACalcArea2ACalcOneWay2Ή
'   2010/12/03 Rev.2.1.2.0 ISHI SSLݒǉAZT[rX֘Aǉ
'   2011/04/26 Rev.2.2.0.0 ISHI UserNXΉAŊZ擾@\ǉ
'   2011/11/07 Rev.2.3.0.0 ISHI CalcRouteACalcOptRouteACalcArea3ACalcOneWay3T[rXΉ
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

Imports System.Collections.Generic
Imports System.Text.RegularExpressions
Imports Act.Dcws

''' <summary>
''' CtH[NX
''' </summary>
''' <remarks></remarks>
Partial Public Class MainForm
    Inherits System.Windows.Forms.Form

    '----------------------------------------------------------------------------------------------
    '	Constants
    '----------------------------------------------------------------------------------------------
#Region "Constants"

    ''' <summary>
    ''' T[rXĂяo^CAEg
    ''' </summary>
    Private Const ServiceTimeout As Int32 = 5 * 60 * 1000

    ''' <summary>
    ''' g厞̔{
    ''' </summary>
    Private Const ZoomInRatio As Double = 0.8
    ''' <summary>
    ''' k̔{
    ''' </summary>
    Private Const ZoomOutRatio As Double = 1.2

    ''' <summary>
    ''' vZp[^ftHgl@ȈՌ^|SxŒl
    ''' </summary>
    Private Const PolygonLevelDefault_ As Int32 = -1
    ''' <summary>
    ''' vZp[^ftHgl@B 10 (0.1bP)
    ''' </summary>
    Private Const TimeRangeDefault_ As Int32 = 10 * 600
    ''' <summary>
    ''' vZp[^ftHgl@h[ic|SxŒl
    ''' </summary>
    Private Const DonutPolygonLevelDefault_ As Int32 = -2

    ''' <summary>
    ''' Xgr[ACẽX^[gn_ʕ
    ''' </summary>
    Private Const StartpointSignature_ As String = " *"

    ''' <summary>
    ''' Xe[^Xo[eLXg@n}̏k
    ''' </summary>
    Private Const StatusBarTextScale_ As String = "kځF #,#1"
    ''' <summary>
    ''' Xe[^Xo[eLXg@vZpHf[^
    ''' </summary>
    Private Const StatusBarTextRoadNote_ As String = "vZpHf[^F "
    ''' <summary>
    ''' Xe[^Xo[eLXg@󋵕\
    ''' </summary>
    Private Const StatusBarTextStatusView_ As String = "󋵕\F "

#End Region

    '----------------------------------------------------------------------------------------------
    '	Private Fields
    '----------------------------------------------------------------------------------------------
#Region "Private Fields"

    ''' <summary>
    ''' [UIuWFNg
    ''' </summary>
    Private user_ As User

    ''' <summary>
    ''' vZT[rXIuWFNg
    ''' </summary>
    Private dcService_ As DCService.ACTDCWS = New DCService.ACTDCWS()

    ''' <summary>
    ''' MappleGC^tF[XIuWFNg
    ''' </summary>
    Private mapSMD_ As MapSMD = New MapSMD()

    ''' <summary>
    ''' [gvZEŒZ[gvZpp[^
    ''' </summary>
    Private crParam_ As DCService.CRParam = New DCService.CRParam()

    ''' <summary>
    ''' B^vZpp[^
    ''' </summary>
    Private caParam_ As DCService.CA3Param = New DCService.CA3Param()

    ''' <summary>
    ''' ГꊇvZpp[^
    ''' </summary>
    Private cowParam_ As DCService.COW3Param = New DCService.COW3Param()

    ''' <summary>
    ''' vZΏےn_i[pXg
    ''' </summary>
    Private locList_ As List(Of DCService.Loc) = New List(Of SampleMG.DCService.Loc)()

    ''' <summary>
    ''' LH׊i[pz
    ''' </summary>
    Private rns_ As DCService.Rn() = Nothing

    ''' <summary>
    ''' oRn_ꗗi[pz
    ''' </summary>
    Private trds_ As DCService.Trd() = Nothing

    ''' <summary>
    ''' B^AГꊇvZX^[gn_locList_CfbNXԍ
    ''' </summary>
    Private areaStartLocIndex_ As Int32

#End Region

    '----------------------------------------------------------------------------------------------
    '  Private Properties
    '----------------------------------------------------------------------------------------------
#Region "Private Properties"

    ''' <summary>
    ''' [UIuWFNg擾Eݒ肷
    ''' </summary>
    Private Property User() As User
        Get
            If Me.user_ Is Nothing Then
                Throw New Exception("[UF؂ƌvZpHf[^̑IsĂ܂B")
            End If
            Return Me.user_
        End Get
        Set(ByVal value As User)
            Me.user_ = value
        End Set
    End Property

#End Region

    '----------------------------------------------------------------------------------------------
    '	Private Methods
    '----------------------------------------------------------------------------------------------
#Region "Private Methods"

    ''' <summary>
    ''' ListView (vZ)XV
    ''' </summary>
    Private Sub UpdateListViewLocs()
        '	ListView ACeSăNA
        listViewLocs.Items.Clear()

        If locList_.Count = 0 Then
            ' n_Ȃꍇ͏I
            Return
        End If

        '	ListView ACeƂċvZf[^ݒ
        For i As Int32 = 0 To locList_.Count - 1
            listViewLocs.Items.Add(Convert.ToString(i + 1))                             '	n_ No.
            listViewLocs.Items(i).SubItems.Add(locList_(i).Tag)                         '	p_
            listViewLocs.Items(i).SubItems.Add(locList_(i).Node)                        '	m[h
            listViewLocs.Items(i).SubItems.Add(locList_(i).Lon)                         '	ox
            listViewLocs.Items(i).SubItems.Add(locList_(i).Lat)                         '	ܓx
            listViewLocs.Items(i).SubItems.Add(locList_(i).DSec.ToString("N0"))         '	v(0.1b)
            listViewLocs.Items(i).SubItems.Add(locList_(i).Time.ToString("N0"))         '	v()
            listViewLocs.Items(i).SubItems.Add(locList_(i).Dist.ToString("N0"))         '	̂(m)
            listViewLocs.Items(i).SubItems.Add(locList_(i).HighwayDSec.ToString("N0"))  '	v(0.1b)
            listViewLocs.Items(i).SubItems.Add(locList_(i).HighwayTime.ToString("N0"))  '	v()
            listViewLocs.Items(i).SubItems.Add(locList_(i).HighwayDist.ToString("N0"))  '	̂(m)
            listViewLocs.Items(i).SubItems.Add(locList_(i).Toll_SS.ToString("N0"))      '	֥y(SS)
            listViewLocs.Items(i).SubItems.Add(locList_(i).Toll_S.ToString("N0"))       '	ʗ(S)
            listViewLocs.Items(i).SubItems.Add(locList_(i).Toll_M.ToString("N0"))       '	^(M)
            listViewLocs.Items(i).SubItems.Add(locList_(i).Toll_L.ToString("N0"))       '	^(L)
            listViewLocs.Items(i).SubItems.Add(locList_(i).Toll_LL.ToString("N0"))      '	嗿(LL)
        Next

        '	B /  ̃X^[gn_̕\
        listViewLocs.Items(areaStartLocIndex_).Text += StartpointSignature_

        Return
    End Sub

    ''' <summary>
    ''' ListView (oRn_ꗗ)XV
    ''' </summary>
    Private Sub UpdateListViewRns()
        '	ListView ACeSăNA
        listViewRns.Items.Clear()

        If rns_ Is Nothing Then
            ' oRn_Ȃꍇ͏I
            Return
        End If

        '	ListView ACeƂċvZf[^ݒ
        For i As Int32 = 0 To rns_.Length - 1
            listViewRns.Items.Add(Convert.ToString(i + 1))                      '	No.
            listViewRns.Items(i).SubItems.Add(rns_(i).LocFlag.ToString())       '	P[VtO
            listViewRns.Items(i).SubItems.Add(rns_(i).LinkFlag.ToString())      '	ڑtO
            listViewRns.Items(i).SubItems.Add(rns_(i).NLCode)                   '	m[h
            listViewRns.Items(i).SubItems.Add(rns_(i).Name)                     '	n_
            listViewRns.Items(i).SubItems.Add(rns_(i).DSec.ToString("N0"))      '	(0.1b)
            listViewRns.Items(i).SubItems.Add(rns_(i).Time.ToString("N0"))      '	()
            listViewRns.Items(i).SubItems.Add(rns_(i).Dist.ToString("N0"))      '	̂(m)
            listViewRns.Items(i).SubItems.Add(rns_(i).Toll_SS.ToString("N0"))   '	֥y(SS)
            listViewRns.Items(i).SubItems.Add(rns_(i).Toll_S.ToString("N0"))    '	ʗ(S)
            listViewRns.Items(i).SubItems.Add(rns_(i).Toll_M.ToString("N0"))    '	^(M)
            listViewRns.Items(i).SubItems.Add(rns_(i).Toll_L.ToString("N0"))    '	^(L)
            listViewRns.Items(i).SubItems.Add(rns_(i).Toll_LL.ToString("N0"))   '	嗿(LL)
            listViewRns.Items(i).SubItems.Add(rns_(i).ICType.ToString())        '	IC 
            listViewRns.Items(i).SubItems.Add(rns_(i).Lon)                      '	ox
            listViewRns.Items(i).SubItems.Add(rns_(i).Lat)                      '	ܓx

        Next

        Return
    End Sub

    ''' <summary>
    ''' ListView (LH)XV
    ''' </summary>
    Private Sub UpdateListViewTrds()
        '	ListView ACeSăNA
        listViewTrds.Items.Clear()

        If trds_ Is Nothing Then
            ' LHׂȂꍇ͏I
            Return
        End If

        '	ListView ACeƂċvZf[^ݒ
        For i As Int32 = 0 To trds_.Length - 1
            listViewTrds.Items.Add(Convert.ToString(i + 1))                         '	No.
            listViewTrds.Items(i).SubItems.Add(trds_(i).InRdName)                   '	H
            listViewTrds.Items(i).SubItems.Add(trds_(i).InICName)                   '	 IC
            listViewTrds.Items(i).SubItems.Add(trds_(i).OutRdName)                  '	oH
            listViewTrds.Items(i).SubItems.Add(trds_(i).OutICName)                  '	o IC
            listViewTrds.Items(i).SubItems.Add(trds_(i).Toll_SS.ToString("N0"))     '	֥y(SS)
            listViewTrds.Items(i).SubItems.Add(trds_(i).Toll_S.ToString("N0"))      '	ʗ(S)
            listViewTrds.Items(i).SubItems.Add(trds_(i).Toll_M.ToString("N0"))      '	^(M)
            listViewTrds.Items(i).SubItems.Add(trds_(i).Toll_L.ToString("N0"))      '	^(L)
            listViewTrds.Items(i).SubItems.Add(trds_(i).Toll_LL.ToString("N0"))     '	嗿(LL)
            listViewTrds.Items(i).SubItems.Add(trds_(i).Dist.ToString("N0"))        '	(km)
        Next

        Return
    End Sub

    ''' <summary>
    ''' n_ǉ
    ''' </summary>
    ''' <param name="lon">ǉn_̌ox</param>
    ''' <param name="lat">ǉn_̈ܓx</param>
    ''' <param name="tag">ǉn_̃^O</param>
    Private Sub AddLocation(ByVal lon As String, ByVal lat As String, ByVal tag As String)
        '	VK P[V IuWFNg̍쐬
        Dim newLoc As New DCService.Loc()
        newLoc.Lon = lon                                                                        '	ox
        newLoc.Lat = lat                                                                        '	ܓx
        newLoc.Tag = If(tag.Length = 0, String.Format("p_{0}", locList_.Count + 1), tag)    '	^O
        newLoc.Node = Convert.ToString(0)                                                       '	m[h

        '	P[VIuWFNgzɃP[VIuWFNgǉ
        locList_.Add(newLoc)

        '	H_̕\
        mapSMD_.DrawLocRange(locList_, locList_.Count - 1)

        '	X^[gn_̏
        If locList_.Count = 1 Then
            '	߂Ďw肳ꂽH_̏ꍇ
            areaStartLocIndex_ = 0
        End If

        '	ListView̍XV
        UpdateListViewLocs()
    End Sub

    ''' <summary>
    ''' [gvZs
    ''' </summary>
    ''' <param name="optimizeMode">ŒZ[gvZ[htO</param>
    Private Sub CalcRoute(ByVal optimizeMode As Boolean)
        '------------------------------------------------------------------------------------------
        '	n_`FbN
        '------------------------------------------------------------------------------------------
        If Not optimizeMode Then
            '	[gvZ
            If (locList_.Count < 2) Then
                MessageBox.Show(Me, "n_Q_ȏw肵ĉB", "x", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If
        Else
            '	ŒZ[gvZ
            If (locList_.Count < 3) Then
                MessageBox.Show(Me, "n_R_ȏw肵ĉB", "x", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If
        End If

        '------------------------------------------------------------------------------------------
        '	ǗT[rX狗vZT[o擾Đݒ
        '------------------------------------------------------------------------------------------
        '	ǗT[rX̃CX^X쐬
        Dim dcAdminService As DCAdmin.ACTDCADMIN = New DCAdmin.ACTDCADMIN() ' ǗT[rXNX
        dcAdminService.Url = Me.User.AdminUrl                               ' ǗT[rXURL
        Dim dcAdminEnviron As DCAdmin.Environ = Me.User.GetAdminEnviron()   ' ǗT[rXݒ

        '  vZT[o擾
        Try
            If Not dcAdminService.GetUsableDCServer(dcAdminEnviron, Me.User.NWInfo) Then
                '  vZT[o̎擾Ɏs
                MessageBox.Show(Me, "vZT[o̎擾Ɏs܂B" + vbCrLf + "vZpHf[^I̐ݒmFĂB", _
                                "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(Me, ex.Message, "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End Try

        '  vZT[o̐ݒ            
        dcService_.Url = Utilities.ChangeProtocol(dcAdminEnviron.WSURL, Me.User.SslMode)    '  vZT[oURL
        Dim dcEnviron As DCService.Environ = Utilities.GetDCServiceEnviron(dcAdminEnviron)  '  vZT[rXݒIuWFNg

        '------------------------------------------------------------------------------------------
        '	vZp[^̐ݒ
        '------------------------------------------------------------------------------------------
        Using frm As RouteForm = New RouteForm(Me.crParam_)      '	[gvZ/ŒZ[gvZݒtH[NX
            If frm.ShowDialog(Me) <> DialogResult.OK Then
                '	LZ
                Return
            End If
        End Using

        '-----------------------------------------------------------------------------------------
        '  P[VwƌvZʎ󂯎p̕ϐݒ
        '-----------------------------------------------------------------------------------------
        Dim locs As DCService.Loc() = New DCService.Loc(locList_.Count - 1) {}  ' P[Vz
        For i As Int32 = 0 To locList_.Count - 1
            locs(i) = New DCService.Loc()
            locs(i).Node = locList_(i).Node
            locs(i).Lon = locList_(i).Lon
            locs(i).Lat = locList_(i).Lat
            locs(i).Tag = locList_(i).Tag
        Next
        Dim pnts As DCService.Pnt() = Nothing                                   ' |Cg̔z
        Dim rns As DCService.Rn() = Nothing                                     ' oRHz
        Dim trds As DCService.Trd() = Nothing                                   ' oRLHz
        Dim nwInfo As DCService.NWInfo = Nothing                                ' vZpHf[^

        '------------------------------------------------------------------------------------------
        '	vZ̎s
        '------------------------------------------------------------------------------------------
        '	}EXJ[\ҋ@
        Dim preCursor As Cursor = Cursor.Current    '	ޔpJ[\
        Cursor.Current = Cursors.WaitCursor
        Try
            '   vZԊu
            If Not WaitForm.WaitCalcTime(Me.User, CalcWaitType.DistCalc, True, Me) Then
                ' LZ
                Return
            End If

            '	vZ̎s
            Dim resultCode As Int32                 ' T[rX̖߂l
            If (Not optimizeMode) Then
                ' [gvZ
                resultCode = dcService_.CalcRoute(dcEnviron, crParam_, locs, pnts, rns, trds, nwInfo)
            Else
                ' ŒZ[gvZ
                resultCode = dcService_.CalcOptRoute(dcEnviron, crParam_, locs, pnts, rns, trds, nwInfo)
            End If
            Me.User.UpdateLastDCTime()
            If resultCode = 0 Then
                '  
                '  vZʂ̕ۑ
                locList_ = New List(Of SampleMG.DCService.Loc)(locs)
                rns_ = rns
                trds_ = trds

                '	vZf[^̒n}ւ̕`
                mapSMD_.DrawDistCalcRoute(locs, pnts)

                '	ListView ̍XV
                UpdateListViewLocs()
                UpdateListViewRns()
                UpdateListViewTrds()

                '  Xe[^Xo[̍XV
                SetStatusViewSuccess(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
            Else
                '  s
                '  G[bZ[W̎擾ƕ\
                Dim errorMessage As String = dcService_.GetDCWSMessage(dcEnviron, resultCode)
                If (Not optimizeMode) Then
                    '  [gvZ
                    MessageBox.Show(Me, "[gvZɎs܂B" + vbCrLf + errorMessage, "vZT[o", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                Else
                    '  ŒZ[gvZ
                    MessageBox.Show(Me, "ŒZ[gvZɎs܂B" + vbCrLf + errorMessage, "vZT[o", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If

                '  Xe[^Xo[̍XV
                SetStatusViewFail(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
            End If
        Catch ex As Exception
            '	ObZ[W̏o
            MessageBox.Show(Me, ex.Message, "vZT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
            '	Xe[^Xo[̍XV
            SetStatusViewFail(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
        Finally
            '	}EXJ[\ɖ߂
            Cursor.Current = preCursor
        End Try
    End Sub

    ''' <summary>
    ''' Xe[^Xo[ɃT[rXĂяobZ[W\
    ''' </summary>
    ''' <param name="url">T[rXURL</param>
    ''' <param name="host">Xi[IPAhX</param>
    ''' <param name="port">Xi[|[gԍ</param>
    Private Sub SetStatusViewSuccess(ByVal url As String, ByVal host As String, ByVal port As String)
        statusLabelStatusView.Text = String.Format("{0}vZT[oURL {1} XiIPAhX {2} |[gԍ {3} 擾܂", _
                                                   StatusBarTextStatusView_, url, host, port)
    End Sub

    ''' <summary>
    ''' Xe[^Xo[ɃT[rXĂяosbZ[W\
    ''' </summary>
    ''' <param name="url">T[rXURL</param>
    ''' <param name="host">Xi[IPAhX</param>
    ''' <param name="port">Xi[|[gԍ</param>
    Private Sub SetStatusViewFail(ByVal url As String, ByVal host As String, ByVal port As String)
        statusLabelStatusView.Text = String.Format("{0}vZT[oURL {1} XiIPAhX {2} |[gԍ {3} ̎擾Ɏs܂", _
                                                   StatusBarTextStatusView_, url, host, port)
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Public Methods
    '----------------------------------------------------------------------------------------------
#Region "Public Methods"

    ''' <summary>
    ''' RXgN^
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub New()
        MyBase.New()

        ' R|[lg̏
        Try
            InitializeComponent()

            '  T[rX̃^CAEgl
            dcService_.Timeout = ServiceTimeout

            '  vZR}hp[^̏
            crParam_ = New DCService.CRParam()
            crParam_.CalcKind = CalcKind.Time                           '  ŒZ
            crParam_.Transport = Transport.None                         '  Hgp
            crParam_.RouteKind = RouteKind.Simple                       '  ȈՃ[g
            crParam_.TollOutput = TollOutput.Output                     '  ʍs̎Zo
            crParam_.HighwayOutput = HighwayOutput.NotOutput            '  HԂ̔\
            crParam_.RnsOutput = RnsOutput.NotOutput                    '  oRn_ꗗ̔o
            crParam_.TrdsOutput = TrdsOutput.NotOutput                  '  LHׂ̔o
            crParam_.PntsOutput = PntsOutput.Output                     '  |Cg̏o

            '  B^pp[^̏
            caParam_.StartPnt = New DCService.NodePnt()                 '  Sn_
            caParam_.CalcKind = CalcKind.Time                           '  ŒZ
            caParam_.Transport = Transport.None                         '  Hgp
            caParam_.AreaDirection = AreaDirection.OutFlow              '  BvZ
            caParam_.AreaKind = AreaKind.Time                           '  
            caParam_.AreaRange = TimeRangeDefault_                      '  10(0.1bP)
            caParam_.PolygonLevel = PolygonLevelDefault_                '  ȈՌ^|S
            caParam_.DonutPolygonLevel = DonutPolygonLevelDefault_      '  h[ic|Sx
            caParam_.PolygonDetail = PolygonDetail.None                 '  |SڍאݒȂ

            '  ГꊇvZpp[^̏
            cowParam_.StartPnt = New DCService.NodePnt()                '  Sn_
            cowParam_.CalcKind = CalcKind.Time                          '  ŒZ
            cowParam_.Transport = Transport.None                        '  Hgp
            cowParam_.AreaDirection = AreaDirection.OutFlow             '  BvZ
            cowParam_.AreaKind = AreaKind.Time                          '  
            cowParam_.AreaRange = TimeRangeDefault_                     '  10(0.1bP)
            cowParam_.HighwayOutput = HighwayOutput.NotOutput           '  HԂ̔\
            cowParam_.TollOutput = TollOutput.NotOutput                 '  ʍs̔\

            '  ڑf[^INIt@C烍[h
            '  USERID
            Dim userID As String = IniFile.GetProfileString(Constants.SectionNameServer, Constants.KeyNameServerUserID, Constants.ServerUserIDDefault)
            '  ǗT[oURL
            Dim adminUrl As String = IniFile.GetProfileString(Constants.SectionNameServer, Constants.KeyNameDCAdminUrl, Constants.DCAdminUrlDefault)
            '  SSL
            Dim sslMode As Boolean = If(IniFile.GetProfileInt(Constants.SectionNameServer, Constants.SslMode, Constants.SslModeDefault) = 0, False, True)
            ' [UIuWFNg쐬
            user_ = New User(userID, "", adminUrl, sslMode)

            '  MappleGC^tF[X̏
            mapSMD_.Initialize(mpgMapControl)
            AddHandler mpgMapControl.MouseWheel, AddressOf mpgMapControl_MouseWheel

            '  Xe[^Xo[̏
            statusLabelScale.Text = mapSMD_.MapScale.ToString(StatusBarTextScale_) '  n}̏k
            statusLabelRoadNote.Text = StatusBarTextRoadNote_                      '  vZpHf[^
            statusLabelStatusView.Text = StatusBarTextStatusView_                  '  󋵕\
        Catch ex As Exception
            MessageBox.Show(ex.Message + vbCrLf + "AvP[VI܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Application.Exit()  '	AvP[V̏I
        End Try

    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Event Handlers
    '----------------------------------------------------------------------------------------------
#Region "Event Handlers"

    '----------------------------------------------------------------------------------------------
    '	t@C
    '----------------------------------------------------------------------------------------------
#Region "t@Cj["

    ''' <summary>
    ''' vZpHf[^I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemSelectRoadData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemSelectRoadData.Click
        Using serverForm As RoadDataForm = New RoadDataForm(Me.User)   ' vZpf[^I_CAO
            If serverForm.ShowDialog(Me) = DialogResult.OK Then
                '	{^ꂽꍇ
                '  [UIuWFNg̍XV
                user_ = serverForm.User

                '	INIt@CփZ[u
                '	USERID
                If IniFile.WriteProfileString(Constants.SectionNameServer, Constants.KeyNameServerUserID, Me.User.UserID) = 0 Then
                    MessageBox.Show(Me, "USERID INIt@Cւ݂̏Ɏs܂B", "G[", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)

                End If
                '	ǗT[o URL
                If IniFile.WriteProfileString(Constants.SectionNameServer, Constants.KeyNameDCAdminUrl, Me.User.AdminUrl) = 0 Then
                    MessageBox.Show(Me, "ǗT[o URL INIt@Cւ݂̏Ɏs܂B", "G[", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
                '	SSL
                If IniFile.WriteProfileInt(Constants.SectionNameServer, Constants.SslMode, If(Me.User.SslMode, 1, 0)) = 0 Then
                    MessageBox.Show(Me, "SSL[h INIt@Cւ݂̏Ɏs܂B", "G[", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If

                '	Xe[^Xo[̍XV
                statusLabelRoadNote.Text = StatusBarTextRoadNote_ + Me.User.NWInfo.Note '	vZpHf[^
                statusLabelStatusView.Text = StatusBarTextStatusView_                   '	󋵕\

                '	vZpHf[^ύXɔ
                menuItemClearNodes.PerformClick()                                       '	H_NA
                menuItemClearMap.PerformClick()                                         '	ʃNA
            End If
        End Using
    End Sub

    ''' <summary>
    ''' AvP[VI
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemExit.Click
        Application.Exit()  '	vȌI
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	ҏW
    '----------------------------------------------------------------------------------------------
#Region "H_w胁j["

    ''' <summary>
    ''' H_
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemClearNodes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemClearNodes.Click, toolButtonClearNodes.Click
        '  NA
        locList_.Clear()

        '	ListView ACẽNA
        listViewLocs.Items.Clear()  '	vZ
        listViewRns.Items.Clear()   '	oRn_ꗗ
        listViewTrds.Items.Clear()  '	L񖾍

    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	\
    '----------------------------------------------------------------------------------------------
#Region "\j["

    ''' <summary>
    ''' Mapple̒n}Ɋւ郂[hݒ肷
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemViewMapControl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemSelectNodes.Click, toolButtonZoomOut.Click, toolButtonZoomIn.Click, toolButtonSelectNodes.Click, toolButtonGrabber.Click, menuItemZoomOut.Click, menuItemZoomIn.Click, menuItemGrabber.Click
        '	UI tÕZbg
        '	Cj[
        menuItemSelectNodes.Checked = False         '	H_I
        menuItemGrabber.Checked = False             '	n}ړ
        menuItemZoomIn.Checked = False              '	g
        menuItemZoomOut.Checked = False             '	k
        '	c[o[{^
        toolButtonSelectNodes.Checked = False       '	H_I
        toolButtonGrabber.Checked = False           '	n}ړ
        toolButtonZoomIn.Checked = False            '	g
        toolButtonZoomOut.Checked = False           '	k

        '	[hl̐ݒ & UI tO̐ݒ
        If (sender Is menuItemSelectNodes OrElse sender Is toolButtonSelectNodes) Then
            '	H_I
            mapSMD_.MapControl = MapOperateMode.PointSelect
            toolButtonSelectNodes.Checked = True
            menuItemSelectNodes.Checked = True
        ElseIf (sender Is menuItemGrabber OrElse sender Is toolButtonGrabber) Then
            '	n}ړ
            mapSMD_.MapControl = MapOperateMode.Grabber
            toolButtonGrabber.Checked = True
            menuItemGrabber.Checked = True
        ElseIf (sender Is menuItemZoomIn OrElse sender Is toolButtonZoomIn) Then
            '	g
            mapSMD_.MapControl = MapOperateMode.ZoomIn
            toolButtonZoomIn.Checked = True
            menuItemZoomIn.Checked = True
        ElseIf (sender Is menuItemZoomOut OrElse sender Is toolButtonZoomOut) Then
            '	k
            mapSMD_.MapControl = MapOperateMode.ZoomOut
            toolButtonZoomOut.Checked = True
            menuItemZoomOut.Checked = True
        End If
    End Sub

    ''' <summary>
    ''' n}̃IuWFNg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemClearMap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemClearMap.Click, toolButtonClearMap.Click
        mapSMD_.ClearMap()  '	ʃNA
    End Sub

    ''' <summary>
    ''' n}̕\kڒlݒ肷
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemViewScale_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemJapan.Click, menuItemLocal2.Click, menuItemLocal1.Click, menuItemWide3.Click, menuItemWide2.Click, menuItemMiddle2.Click, menuItemMiddle1.Click, menuItemDetail3.Click, menuItemDetail2.Click, menuItemDetail1.Click, contextMenuItemWide3.Click, contextMenuItemWide2.Click, contextMenuItemMiddle2.Click, contextMenuItemMiddle1.Click, contextMenuItemLocal2.Click, contextMenuItemLocal1.Click, contextMenuItemJapan.Click, contextMenuItemDetail3.Click, contextMenuItemDetail2.Click, contextMenuItemDetail1.Click, menuItemWide1.Click, menuItemLocal3.Click, contextMenuItemWide1.Click, contextMenuItemLocal3.Click
        '	n}̕\kڒl̐ݒ
        If (sender Is menuItemJapan OrElse sender Is contextMenuItemJapan) Then
            mapSMD_.MapScale = 5000000      '	k5001
        ElseIf (sender Is menuItemLocal1 OrElse sender Is contextMenuItemLocal1) Then
            mapSMD_.MapScale = 3000000      '	k3001
        ElseIf (sender Is menuItemLocal2 OrElse sender Is contextMenuItemLocal2) Then
            mapSMD_.MapScale = 1500000      '	k1501
        ElseIf (sender Is menuItemLocal3 OrElse sender Is contextMenuItemLocal3) Then
            mapSMD_.MapScale = 1000000      '	k1001
        ElseIf (sender Is menuItemWide1 OrElse sender Is contextMenuItemWide1) Then
            mapSMD_.MapScale = 500000       '	k501
        ElseIf (sender Is menuItemWide2 OrElse sender Is contextMenuItemWide2) Then
            mapSMD_.MapScale = 200000       '	k201
        ElseIf (sender Is menuItemWide3 OrElse sender Is contextMenuItemWide3) Then
            mapSMD_.MapScale = 100000       '	k101
        ElseIf (sender Is menuItemMiddle1 OrElse sender Is contextMenuItemMiddle1) Then
            mapSMD_.MapScale = 50000        '	k51
        ElseIf (sender Is menuItemMiddle2 OrElse sender Is contextMenuItemMiddle2) Then
            mapSMD_.MapScale = 25000        '	k25番1
        ElseIf (sender Is menuItemDetail1 OrElse sender Is contextMenuItemDetail1) Then
            mapSMD_.MapScale = 10000        '	k11
        ElseIf (sender Is menuItemDetail2 OrElse sender Is contextMenuItemDetail2) Then
            mapSMD_.MapScale = 5000         '	k50001
        ElseIf (sender Is menuItemDetail3 OrElse sender Is contextMenuItemDetail3) Then
            mapSMD_.MapScale = 2500         '	k25001
        Else
            Return                          '	ȊO
        End If

        ' ReLXgj[̓NbNn_Ɉړ
        If (sender Is contextMenuItemJapan OrElse sender Is contextMenuItemLocal1 _
            OrElse sender Is contextMenuItemLocal2 OrElse sender Is contextMenuItemLocal3 _
            OrElse sender Is contextMenuItemWide1 OrElse sender Is contextMenuItemWide2 _
            OrElse sender Is contextMenuItemWide3 OrElse sender Is contextMenuItemMiddle1 _
            OrElse sender Is contextMenuItemMiddle2 OrElse sender Is contextMenuItemDetail1 _
            OrElse sender Is contextMenuItemDetail2 OrElse sender Is contextMenuItemDetail3) Then
            mapSMD_.PanMap(mapSMD_.RightMouseButtonDownPoint)
            mapSMD_.ClearRightMouseButtonDownPoint()
        End If

        '	Xe[^Xo[̍XV
        statusLabelScale.Text = mapSMD_.MapScale.ToString(StatusBarTextScale_)

    End Sub

    ''' <summary>
    ''' TCY̊g
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemTextLevelLarge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemTextLevelLarge.Click
        '	UI̍XV
        menuItemTextLevelLarge.Checked = True       '	
        menuItemTextLevelSmall.Checked = False      '	
        '	TCY̕ύX
        mapSMD_.PointTextSize = PointTextSize.Large
    End Sub

    ''' <summary>
    ''' TCY̏k
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemTextLevelSmall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemTextLevelSmall.Click
        '	UI̍XV
        menuItemTextLevelLarge.Checked = False      '	
        menuItemTextLevelSmall.Checked = True       '	
        '	TCY̕ύX
        mapSMD_.PointTextSize = PointTextSize.Small
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	vZ
    '----------------------------------------------------------------------------------------------
#Region "vZj["

    ''' <summary>
    ''' [gvZs
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemCalcRoute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemCalcRoute.Click, toolButtonCalcRoute.Click
        CalcRoute(False)
    End Sub

    ''' <summary>
    ''' ŒZ[gvZs
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemCalcOptRoute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemCalcOptRoute.Click, toolButtonCalcOptRoute.Click
        CalcRoute(True)
    End Sub

    ''' <summary>
    ''' BvZ or vZs
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemCalcArea_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemCalcArea.Click, toolButtonCalcArea.Click
        '------------------------------------------------------------------------------------------
        '	ʕۑz̃Zbg
        '------------------------------------------------------------------------------------------
        rns_ = Nothing  '	oRn_ꗗ
        trds_ = Nothing '	LH

        '------------------------------------------------------------------------------------------
        '	vZJnn_̐ݒ
        '------------------------------------------------------------------------------------------
        '	X^[gn_w肳Ă邩
        If locList_.Count = 0 Then
            MessageBox.Show(Me, "n_w肵ĉB", "x", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        '	n_f[^
        caParam_.StartPnt.Node = "0"                                '	m[h
        caParam_.StartPnt.Lon = locList_(areaStartLocIndex_).Lon    '	ox
        caParam_.StartPnt.Lat = locList_(areaStartLocIndex_).Lat    '	ܓx

        '------------------------------------------------------------------------------------------
        '	ǗT[rX狗vZT[o擾Đݒ
        '------------------------------------------------------------------------------------------
        '	ǗT[rX̃CX^X쐬
        Dim dcAdminService As DCAdmin.ACTDCADMIN = New DCAdmin.ACTDCADMIN() ' ǗT[rXNX
        dcAdminService.Url = Me.User.AdminUrl                               ' ǗT[rXURL
        Dim dcAdminEnviron As DCAdmin.Environ = Me.User.GetAdminEnviron()   ' ǗT[rXݒ

        '  vZT[o擾
        Try
            If Not dcAdminService.GetUsableDCServer(dcAdminEnviron, Me.User.NWInfo) Then
                '  vZT[o̎擾Ɏs
                MessageBox.Show(Me, "vZT[o̎擾Ɏs܂B" + vbCrLf + "vZpHf[^I̐ݒmFĂB", _
                                "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(Me, ex.Message, "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End Try

        '  vZT[o̐ݒ            
        dcService_.Url = Utilities.ChangeProtocol(dcAdminEnviron.WSURL, Me.User.SslMode)    '  vZT[oURL
        Dim dcEnviron As DCService.Environ = Utilities.GetDCServiceEnviron(dcAdminEnviron)  '  vZT[rXݒIuWFNg

        '------------------------------------------------------------------------------------------
        '	vZp[^̐ݒ
        '------------------------------------------------------------------------------------------
        Using form As AreaForm = New AreaForm(caParam_)        '	B/vZݒtH[NX
            If form.ShowDialog(Me) <> DialogResult.OK Then
                '	LZ
                Return
            End If
        End Using

        '------------------------------------------------------------------------------------------
        '	vZʎ󂯎p̕ϐݒ
        '------------------------------------------------------------------------------------------
        Dim points As DCService.Pnt() = Nothing                 '  |Cg\̂̔z
        Dim nwInfo As DCService.NWInfo = Nothing                '  vZpHf[^\

        '------------------------------------------------------------------------------------------
        '	vZ̎s
        '------------------------------------------------------------------------------------------ 
        '	}EXJ[\ҋ@
        Dim preCursor As Cursor = Cursor.Current                            '	ޔpJ[\
        Cursor.Current = Cursors.WaitCursor

        Try
            '   vZԊu
            If Not WaitForm.WaitCalcTime(Me.User, CalcWaitType.DistCalc, True, Me) Then
                ' LZ
                Return
            End If

            ' vZ̎s
            Dim polygonDetailBeforeCalc As Int32 = caParam_.PolygonDetail   '  vZȌԂۑ
            Dim resultCode As Int32                                         '  vŽʃR[h
            resultCode = dcService_.CalcArea3(dcEnviron, caParam_, points, nwInfo)
            Me.User.UpdateLastDCTime()
            If resultCode = 0 Then
                ' 
                ' vZf[^̒n}ւ̕`
                mapSMD_.DrawDistCalcArea(points, caParam_.StartPnt)

                ' ListView ̍XV
                UpdateListViewLocs()
                UpdateListViewRns()
                UpdateListViewTrds()

                ' Xe[^Xo[̍XV
                SetStatusViewSuccess(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())

                ' |SԂsȂꍇ
                If (((caParam_.PolygonDetail And (PolygonDetail.ExpandMiddle Or PolygonDetail.ExpandTerminal)) _
                     <> (polygonDetailBeforeCalc And (PolygonDetail.ExpandMiddle Or PolygonDetail.ExpandTerminal)))) Then
                    If caParam_.PolygonKind = PolygonKind.SinglePolygon Then
                        ' P|S̏ꍇ
                        MessageBox.Show(Me, "B^m[h邽߁A|SԂ͎s܂łB", _
                                        "|S", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    End If
                End If
                ' vZȌԂɖ߂
                caParam_.PolygonDetail = polygonDetailBeforeCalc

            Else
                '  s
                '  G[bZ[W̎擾ƕ\
                Dim errorMessage As String = dcService_.GetDCWSMessage(dcEnviron, resultCode)
                If caParam_.AreaDirection = AreaDirection.OutFlow Then
                    MessageBox.Show(Me, "BvZɎs܂B" + vbCrLf + errorMessage, "vZT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Else
                    MessageBox.Show(Me, "vZɎs܂B" + vbCrLf + errorMessage, "vZT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If

                '	Xe[^Xo[̍XV
                SetStatusViewFail(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
            End If
        Catch ex As Exception
            '	ObZ[W̏o
            MessageBox.Show(Me, ex.Message, "vZT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)

            '	Xe[^Xo[̍XV
            SetStatusViewFail(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
        Finally
            '	}EXJ[\ɖ߂
            Cursor.Current = preCursor
        End Try

    End Sub

    ''' <summary>
    ''' ГꊇvZs
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemCalcOneWay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemCalcOneWay.Click, toolButtonCalcOneWay.Click
        '------------------------------------------------------------------------------------------
        '	vZR}h\̓̔zf[^̃Zbg
        '------------------------------------------------------------------------------------------
        rns_ = Nothing               '	oRn_ꗗ
        trds_ = Nothing              '	LH

        '------------------------------------------------------------------------------------------
        '	vZJnn_̐ݒ
        '------------------------------------------------------------------------------------------
        If locList_.Count = 0 Then
            '	X^[gn_w肳ĂȂ
            MessageBox.Show(Me, "n_w肵ĉB", "x", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        '	n_f[^
        cowParam_.StartPnt.Node = "0"                               '	m[h
        cowParam_.StartPnt.Lon = locList_(areaStartLocIndex_).Lon   '	ox
        cowParam_.StartPnt.Lat = locList_(areaStartLocIndex_).Lat   '	ܓx

        '------------------------------------------------------------------------------------------
        '	ǗT[o狗vZT[o̐ݒ
        '------------------------------------------------------------------------------------------
        '	ǗT[rX̃CX^X쐬
        Dim dcAdminService As DCAdmin.ACTDCADMIN = New DCAdmin.ACTDCADMIN() ' ǗT[rXNX
        dcAdminService.Url = Me.User.AdminUrl                               ' ǗT[rXURL
        Dim dcAdminEnviron As DCAdmin.Environ = Me.User.GetAdminEnviron()   ' ǗT[rXݒ

        '  vZT[o擾
        Try
            If Not dcAdminService.GetUsableDCServer(dcAdminEnviron, Me.User.NWInfo) Then
                '  vZT[o̎擾Ɏs
                MessageBox.Show(Me, "vZT[o̎擾Ɏs܂B" + vbCrLf + "vZpHf[^I̐ݒmFĂB", _
                                "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(Me, ex.Message, "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End Try

        '  vZT[o̐ݒ            
        dcService_.Url = Utilities.ChangeProtocol(dcAdminEnviron.WSURL, Me.User.SslMode)    '  vZT[oURL
        Dim dcEnviron As DCService.Environ = Utilities.GetDCServiceEnviron(dcAdminEnviron)  '  vZT[rXݒIuWFNg

        '------------------------------------------------------------------------------------------
        '	vZp[^̐ݒ
        '------------------------------------------------------------------------------------------
        Using form As OneWayForm = New OneWayForm(cowParam_)        '	ГꊇvZݒtH[NX
            If form.ShowDialog(Me) <> DialogResult.OK Then
                '	LZ
                Return
            End If
        End Using

        '------------------------------------------------------------------------------------------
        '	P[VwƌvZʎ󂯎p̕ϐݒ
        '------------------------------------------------------------------------------------------
        Dim locs(locList_.Count - 1) As DCService.Loc           'P[V\̔z
        For i As Int32 = 0 To locList_.Count - 1
            locs(i) = New DCService.Loc()
            locs(i).Node = locList_(i).Node
            locs(i).Lon = locList_(i).Lon
            locs(i).Lat = locList_(i).Lat
            locs(i).Tag = locList_(i).Tag
        Next
        Dim nwInfo As DCService.NWInfo = Nothing               'vZpHf[^\

        '------------------------------------------------------------------------------------------
        '	vZ̎s
        '------------------------------------------------------------------------------------------
        '	}EXJ[\ҋ@
        Dim preCursor As Cursor = Cursor.Current            '	ޔpJ[\
        Cursor.Current = Cursors.WaitCursor

        Try
            '   vZԊu
            If Not WaitForm.WaitCalcTime(Me.User, CalcWaitType.DistCalc, True, Me) Then
                ' LZ
                Return
            End If

            '	vZ̎s
            Dim resultCode As Int32                         '  vŽʃR[h
            resultCode = dcService_.CalcOneWay3(dcEnviron, cowParam_, locs, nwInfo)
            Me.User.UpdateLastDCTime()
            If resultCode = 0 Then
                '  
                '  vZʕۑ
                locList_ = New List(Of DCService.Loc)(locs)

                '	vZf[^̒n}ւ̕`
                mapSMD_.DrawDistCalcOneWay(locList_, cowParam_.StartPnt)

                '	ListView ̍XV
                UpdateListViewLocs()
                UpdateListViewRns()
                UpdateListViewTrds()

                '	Xe[^Xo[̍XV
                SetStatusViewSuccess(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
            Else

                '  G[bZ[W̎擾ƕ\
                Dim errorMessage As String = dcService_.GetDCWSMessage(dcEnviron, resultCode)
                MessageBox.Show(Me, "ГꊇvZɎs܂B" + vbCrLf + errorMessage, "vZT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)

                '	Xe[^Xo[̍XV
                SetStatusViewFail(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
            End If

        Catch ex As Exception
            '	ObZ[W̏o
            MessageBox.Show(Me, ex.Message, "vZT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)

            '	Xe[^Xo[̍XV
            SetStatusViewFail(dcService_.Url, dcEnviron.Host, dcEnviron.Port.ToString())
        Finally
            '	}EXJ[\ɖ߂
            Cursor.Current = preCursor
        End Try
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Z
    '----------------------------------------------------------------------------------------------
#Region "Z"

    ''' <summary>
    ''' ZtH[\
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemSearchAddress_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemSearchAddress.Click
        ' [hZɂătH[쐬
        Using form As New SearchAddressForm(Me.User, SearchMode.Address)
            form.PointName = String.Format("p_{0}", locList_.Count + 1) ' n_ݒ
            If form.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                ' OK̏ꍇ͑IZ𓹘H_ƂĒǉ
                AddLocation(form.ResultLon, form.ResultLat, form.PointName)
            End If
        End Using
    End Sub

    ''' <summary>
    ''' X֔ԍtH[\
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemSearchZipCode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemSearchZipCode.Click
        ' [hX֔ԍɂătH[쐬
        Using form As New SearchAddressForm(Me.User, SearchMode.Zip)
            form.PointName = String.Format("p_{0}", locList_.Count + 1) ' n_ݒ
            If form.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                ' OK̏ꍇ͑IZ𓹘H_ƂĒǉ
                AddLocation(form.ResultLon, form.ResultLat, form.PointName)
            End If
        End Using
    End Sub

    ''' <summary>
    ''' ŊZ擾
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemGetNearestAddress_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemGetNearestAddress.Click
        Try
            Me.Cursor = Cursors.WaitCursor

            '------------------------------------------------------------------------------------------
            '   In_mF
            '------------------------------------------------------------------------------------------
            If listViewLocs.SelectedIndices.Count = 0 Then
                MessageBox.Show(Me, "ŊZ擾n_XgIĂB", _
                                "ŊZ擾", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If

            '------------------------------------------------------------------------------------------
            '   ǗT[rXZT[o擾Đݒ
            '------------------------------------------------------------------------------------------
            ' ǗT[rX̃CX^X쐬
            Dim adminService As DCAdmin.ACTDCADMIN = New DCAdmin.ACTDCADMIN()   ' ǗT[rX
            adminService.Url = Me.User.AdminUrl                                 ' ǗT[rXURLݒ
            Dim adminEnviron As DCAdmin.Environ = Me.User.GetAdminEnviron()     ' ǗT[rXpݒ

            ' ZT[o[擾
            Try
                If Not adminService.GetUsableGeoServer(adminEnviron) Then
                    ' ZT[o̎擾Ɏs
                    MessageBox.Show(Me, "ZT[o̎擾Ɏs܂B", "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If
            Catch ex As Exception
                MessageBox.Show(Me, ex.Message, "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End Try

            ' ZT[rXIuWFNg쐬
            Dim gcService As GCService.ACTGCWS = New GCService.ACTGCWS()
            gcService.Url = Utilities.ChangeProtocol(adminEnviron.WSURL, Me.User.SslMode)    ' ZT[oURL

            '------------------------------------------------------------------------------------------
            '   p[^ݒ
            '------------------------------------------------------------------------------------------
            ' ZT[rXݒ
            Dim gcEnviron As GCService.Environ = Utilities.GetGCServiceEnviron(adminEnviron)

            ' p[^ݒ
            Dim param As GCService.CommonParam = New GCService.CommonParam()
            param.Datum = Act.Dcws.Datum.Tokyo
            param.SearchFlag = 0

            ' ŊZ擾ACeݒ
            Dim selectedItems As List(Of DCService.Loc) = New List(Of SampleMG.DCService.Loc)()
            If listViewLocs.SelectedIndices.Count > 0 Then
                For Each index As Integer In listViewLocs.SelectedIndices
                    selectedItems.Add(Me.locList_(index))
                Next
            End If
            Dim items As GCService.GetNearestAddressItem() = New SampleMG.GCService.GetNearestAddressItem(selectedItems.Count) {}
            For i As Integer = 0 To selectedItems.Count - 1
                items(i) = New SampleMG.GCService.GetNearestAddressItem()
                items(i).SearchLon = selectedItems(i).Lon
                items(i).SearchLat = selectedItems(i).Lat
            Next

            ' pZf[^
            Dim geoInfo As GCService.GeoInfo = New SampleMG.GCService.GeoInfo()

            '------------------------------------------------------------------------------------------
            '   T[rXďo
            '------------------------------------------------------------------------------------------
            WaitForm.WaitCalcTime(Me.User, CalcWaitType.GeoSearch, False, Me)
            Dim resultCode As Integer = gcService.GetNearestAddress(gcEnviron, param, items, geoInfo)
            Me.User.UpdateLastGCTime()
            If resultCode = 0 Then
                ' ʕ\
                For i As Integer = 0 To items.Length - 1
                    If Not items(i).FullAddress Is Nothing AndAlso items(i).FullAddress <> "" Then
                        selectedItems(i).Tag = items(i).FullAddress
                    End If
                Next
                UpdateListViewLocs()
            Else
                '  G[bZ[W̎擾ƕ\
                Dim errorMessage As String = gcService.GetGCWSMessage(gcEnviron, resultCode)
                MessageBox.Show(Me, "ŊZ擾Ɏs܂B" + Environment.NewLine + errorMessage, _
                                "ZT[o", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        Catch ex As Exception
            MessageBox.Show(Me, "menuItemGetNearestAddress_ClickŗO:" + Environment.NewLine + ex.Message + Environment.NewLine + ex.StackTrace, _
                            "G[", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            Me.Cursor = Cursors.Default
        End Try
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	wv
    '----------------------------------------------------------------------------------------------
#Region "wvj["

    ''' <summary>
    ''' [U\
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemUserInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemUserInfo.Click
        Try

            Using form As UserInfoForm = New UserInfoForm(Me.User)
                form.ShowDialog(Me)
            End Using
        Catch
            MessageBox.Show(Me, "[U̕\Ɏs܂B" + Environment.NewLine + "vZpHf[^ɑIĂB", _
                "[U\", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' o[W_CAOĂяo
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub menuItemVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuItemVersion.Click
        Using form As AboutForm = New AboutForm() '	o[W_CAO
            form.ShowDialog(Me)
        End Using
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	MappleG
    '----------------------------------------------------------------------------------------------
#Region "MappleG"

    ''' <summary>
    ''' }EXNbN
    ''' ꂼ̒n}샂[hɂNbN
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub mpgMapControl_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles mpgMapControl.MouseClick
        If e.Button = MouseButtons.Left Then
            '  {^
            Select Case mapSMD_.MapControl
                Case MapOperateMode.PointSelect
                    '	H_I
                    AddLocation((Convert.ToDouble(mapSMD_.LeftMouseButtonDownPoint.X) / 3600000.0).ToString("0.######"), _
                                (Convert.ToDouble(mapSMD_.LeftMouseButtonDownPoint.Y) / 3600000.0).ToString("0.######"), "")
                Case MapOperateMode.Grabber
                    ' n}ړ
                Case MapOperateMode.ZoomIn
                    '	g
                    mapSMD_.MapScale = Convert.ToInt32(mapSMD_.MapScale * ZoomInRatio)      '	kڒl̕ύX
                    mapSMD_.PanMap(mapSMD_.LeftMouseButtonDownPoint)                        '	In_𒆉
                    statusLabelScale.Text = mapSMD_.MapScale.ToString(StatusBarTextScale_)  '	Xe[^Xo[̍XV
                Case MapOperateMode.ZoomOut
                    '	k
                    mapSMD_.MapScale = Convert.ToInt32(mapSMD_.MapScale * ZoomOutRatio)     '	kڒl̕ύX
                    mapSMD_.PanMap(mapSMD_.LeftMouseButtonDownPoint)                        '	In_𒆉

                    statusLabelScale.Text = mapSMD_.MapScale.ToString(StatusBarTextScale_)  '	Xe[^Xo[̍XV
            End Select
        End If
    End Sub

    ''' <summary>
    ''' }EXzC[Cxg
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub mpgMapControl_MouseWheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        '	Xe[^Xo[̍XV
        statusLabelScale.Text = mapSMD_.MapScale.ToString(StatusBarTextScale_)
    End Sub

    ''' <summary>
    ''' ReLXgj[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub contextMenuMap_Closed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripDropDownClosedEventArgs) Handles contextMenuMap.Closed
        If e.CloseReason <> ToolStripDropDownCloseReason.ItemClicked Then
            ' ReLXgj[ACeIȂꍇAENbNn_NA
            mapSMD_.ClearRightMouseButtonDownPoint()
        End If

    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	ListView
    '----------------------------------------------------------------------------------------------
#Region "ListView"

    ''' <summary>
    ''' ListView (vZ)Ń}EX_uNbN
    ''' ListView (vZ)̑Iꂽs̒n_n}̒ɂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub listViewLocs_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles listViewLocs.MouseDoubleClick
        If listViewLocs.SelectedIndices.Count > 0 Then
            '	IĂACeꍇ
            '	In_𒆉
            mapSMD_.PanMap(MapSMD.CreatePointLL(locList_(listViewLocs.SelectedIndices(0)).Lon, _
                                                locList_(listViewLocs.SelectedIndices(0)).Lat))
        End If

    End Sub

    ''' <summary>
    ''' B^vZAГꊇvZ̒Sn_Ɏw胁j[I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub contextMenuItemStartPoint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles contextMenuItemStartPoint.Click
        If listViewLocs.SelectedIndices.Count > 0 Then
            '	IĂACeꍇ
            '	VKX^[gn_̎w
            areaStartLocIndex_ = listViewLocs.SelectedIndices(0)
            '	ListView ̍XV
            UpdateListViewLocs()
        End If
    End Sub

    ''' <summary>
    ''' ListView (vZ)̃ReLXgj[JO
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub contextMenuLocsList_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles contextMenuLocsList.Opening
        If listViewLocs.SelectedIndices.Count <> 1 Then
            e.Cancel = True
        End If
    End Sub

#End Region

#End Region

End Class

