'//////////////////////////////////////////////////////////////////////////////////////////////////
' 
'   ACTvZT[rX TvvO
'   MappleGC^tF[XNX
'
'   Copyrights (c) 2004-2011 Advanced Core Technologies, Inc. All rights reserved.
'
'   2004/09/09 Rev.1.00    TAT ō쐬
'   2004/12/29 Rev.1.01    RIN vZT[rXpƂďC
'   2009/01/21 Rev.2.0.1.0 ISHI |SΉAГꊇvZʕ\Ή
'   2010/02/16 Rev.2.0.1.1 ISHI |S̕\̗C
'   2010/09/16 Rev.2.1.1.0 ISHI MappleGΉ
'   2010/12/03 Rev.2.1.2.0 ISHI DrawLocRangeǉ
'   2011/11/07 Rev.2.3.0.0 ISHI CalcRouteACalcArea3ACalcOneWay3T[rXΉ
'
'//////////////////////////////////////////////////////////////////////////////////////////////////

Imports System.IO
Imports System.Collections.Generic
Imports SampleMG.DCService
Imports MpgCommon
Imports MpgMap
Imports MpgCustom

''' <summary>
''' n}샂[h
''' </summary>
''' <remarks></remarks>
Public Enum MapOperateMode
    ''' <summary>
    ''' H_I
    ''' </summary>
    ''' <remarks></remarks>
    PointSelect = 0
    ''' <summary>
    ''' n}ړ
    ''' </summary>
    Grabber = 1
    ''' <summary>
    ''' g
    ''' </summary>
    ZoomIn = 2
    ''' <summary>
    ''' k
    ''' </summary>
    ZoomOut = 3
End Enum


''' <summary>
''' n_̃eLXgTCY
''' </summary>
Public Enum PointTextSize
    ''' <summary>
    ''' 
    ''' </summary>
    Small = 0
    ''' <summary>
    ''' 
    ''' </summary>
    Large = 1
End Enum

''' <summary>
''' MappleGC^[tF[XNX
''' </summary>
''' <remarks></remarks>
Public Class MapSMD
    '----------------------------------------------------------------------------------------------
    '	Constants
    '----------------------------------------------------------------------------------------------
#Region "Constants"

    ''' <summary>
    ''' oH`Ŏgpłőm[h
    ''' </summary>
    Private Const MaxLinePointCount_ As Int32 = 300000

    ''' <summary>
    ''' B / EГꊇvZ̃X^[gn_̃eLXg
    ''' </summary>
    Private Const StartPointText_ As String = "START"

    ''' <summary>
    ''' [g\p̃y̑
    ''' </summary>
    Private Const RouteLieWidth_ As Single = 3.0F

    ''' <summary>
    ''' |S̃C\p̃y̑
    ''' </summary>
    Private Const PolygonLineWidth_ As Single = 3.0F

    ''' <summary>
    ''' h[ic|S̃C\p̃y̑
    ''' </summary>
    Private Const DonutPolygonLieWidth_ As Single = 3.0F

#End Region

    '----------------------------------------------------------------------------------------------
    '	Private Fields
    '----------------------------------------------------------------------------------------------
#Region "Private Fields"

    ''' <summary>
    ''' MappleGn}`Rg[
    ''' </summary>
    Private mpgMap_ As MpgMap.MpgMap

    ''' <summary>
    ''' n}Ɋւ郂[h
    ''' </summary>
    Private mapMode_ As MapOperateMode

    ''' <summary>
    ''' JX^IuWFNgXg
    ''' </summary>
    Private customObjectList_ As ArrayList = New ArrayList()

    ''' <summary>
    ''' ɃJX^IuWFNgǉƂɎgpIDԍ
    ''' </summary>
    Private nextCustomID_ As Long = 0

    ''' <summary>
    ''' [g̃C\py
    ''' </summary>
    Private routeLinePen_ As Pen = New Pen(Color.Red, RouteLieWidth_)

    ''' <summary>
    ''' |S̃C\py
    ''' </summary>
    Private polygonLinePen_ As Pen = New Pen(Color.Blue, PolygonLineWidth_)

    ''' <summary>
    ''' |S̗̈p̃uV
    ''' </summary>
    Private polygonBrush_ As Brush = Nothing

    ''' <summary>
    ''' h[ic|S̃C\py
    ''' </summary>
    Private donutPolygonLinePen_ As Pen = New Pen(Color.Red, DonutPolygonLieWidth_)

    ''' <summary>
    ''' h[ic|S̗̈p̃uV
    ''' </summary>
    Private donutPolygonBrush_ As Brush = Nothing

    ''' <summary>
    ''' n_̃̕tHg 
    ''' </summary>
    Private pointFontSmall_ As Font = New Font("lr SVbN", 11, FontStyle.Regular, GraphicsUnit.Pixel)

    ''' <summary>
    ''' n_̃̕tHg@
    ''' </summary>
    Private pointFontLarge_ As Font = New Font("lr SVbN", 18, FontStyle.Regular, GraphicsUnit.Pixel)

    ''' <summary>
    ''' n_̐̕F
    ''' </summary>
    Private pointTextColor_ As Color = Color.Black

    ''' <summary>
    ''' n_̔wĩuV
    ''' </summary>
    Private pointBackGroundBrush As Brush = New SolidBrush(Color.Yellow)

    ''' <summary>
    ''' n_̃ACR
    ''' </summary>
    Private pointIcon_ As Icon = My.Resources.PointIcon

    ''' <summary>
    ''' n_̕TCY
    ''' </summary>
    Private pointTextSize_ As PointTextSize = PointTextSize.Small

    ''' <summary>
    ''' n}ړ[h̃}EXJ[\
    ''' </summary>
    Private cursorGrabber_ As Cursor

    ''' <summary>
    ''' n}g僂[h̃}EXJ[\
    ''' </summary>
    Private cursorZoomIn_ As Cursor

    ''' <summary>
    ''' n}k[h̃}EXJ[\
    ''' </summary>
    Private cursorZoomOut_ As Cursor

    ''' <summary>
    ''' NbŇoܓx
    ''' </summary>
    Private leftMouseButtonDownPoint_ As PointLL = New PointLL(0, 0)

    ''' <summary>
    ''' ENbŇoܓx
    ''' </summary>
    Private rightMouseButtonDownPoint_ As PointLL = New PointLL(0, 0)

#End Region

    '----------------------------------------------------------------------------------------------
    '	Properties
    '----------------------------------------------------------------------------------------------
#Region "Properties"

    ''' <summary>
    ''' n}Ń}EX̍NbNƂ̍W擾Eݒ肷
    ''' </summary>
    Public Property LeftMouseButtonDownPoint() As PointLL
        Get
            Return leftMouseButtonDownPoint_
        End Get
        Private Set(ByVal value As PointLL)
            leftMouseButtonDownPoint_ = value
        End Set
    End Property

    ''' <summary>
    ''' n}Ń}EX̉ENbNƂ̍W擾Eݒ肷
    ''' </summary>
    Public Property RightMouseButtonDownPoint() As PointLL
        Get
            Return rightMouseButtonDownPoint_
        End Get
        Private Set(ByVal value As PointLL)
            rightMouseButtonDownPoint_ = value
        End Set
    End Property

    ''' <summary>
    ''' n}Ɋւ郂[h擾Eݒ肷
    ''' </summary>
    Public Property MapControl() As MapOperateMode
        Get
            Return mapMode_
        End Get
        Set(ByVal value As MapOperateMode)
            '	[hl MappleGRg[̒n}샂[hƃJ[\̐ݒs
            Select Case value
                Case MapOperateMode.PointSelect         '	H_I
                    mpgMap_.MapMode = MapMode.Write
                    mpgMap_.Cursor = Cursors.Default
                Case MapOperateMode.Grabber             '	n}ړ
                    mpgMap_.MapMode = MapMode.Move
                    mpgMap_.Cursor = cursorGrabber_
                Case MapOperateMode.ZoomIn              '	g
                    mpgMap_.MapMode = MapMode.Write
                    mpgMap_.Cursor = cursorZoomIn_
                Case MapOperateMode.ZoomOut             '	k
                    mpgMap_.MapMode = MapMode.Write
                    mpgMap_.Cursor = cursorZoomOut_
                Case Else                               '	ȊO
                    Return
            End Select
            '	[hl̐ݒ
            mapMode_ = value
        End Set
    End Property

    ''' <summary>
    ''' n}̕\kڒl擾Eݒ肷
    ''' </summary>
    Public Property MapScale() As Int32
        Get
            Return mpgMap_.MapScale
        End Get
        Set(ByVal value As Int32)
            mpgMap_.MapScale = value       ' kڒl̐ݒ
            mpgMap_.RePaint()              ' ĕ`
        End Set
    End Property

    ''' <summary>
    ''' n_̕TCY擾Eݒ肷
    ''' </summary>
    Public Property PointTextSize() As PointTextSize
        Get
            Return pointTextSize_
        End Get
        Set(ByVal value As PointTextSize)
            pointTextSize_ = value
        End Set
    End Property

#End Region

    '----------------------------------------------------------------------------------------------
    '	Private Methods
    '----------------------------------------------------------------------------------------------
#Region "Private Methods"

    ''' <summary>
    ''' eLXgIuWFNgǉ
    ''' </summary>
    ''' <param name="point">ǉeLXgIuWFNǧoܓx</param>
    ''' <param name="labelText">ǉeLXgIuWFNg̃xeLXg</param>
    ''' <returns>ꍇTrueAsꍇFalse</returns>
    Private Function AddText(ByVal point As PointLL, ByVal labelText As String) As Boolean
        Try
            ' eLXgIuWFNg쐬
            Dim textObject As TextObject = New TextObject()
            textObject.ID = nextCustomID_.ToString()
            textObject.Point = point
            textObject.OriginStyle = MpgCustomEnum.OriginStyleEnum.Icon
            textObject.BallonStyle = MpgCustomEnum.BallonStyleEnum.TitleAndImage
            textObject.Icon = pointIcon_.ToBitmap()
            textObject.Title = labelText
            textObject.TextColor = pointTextColor_
            textObject.pen = Nothing
            textObject.brush = pointBackGroundBrush
            If pointTextSize_ = PointTextSize.Small Then
                ' eLXgTCY
                textObject.Offset = New Point(32, 16)
                textObject.TitleFont = pointFontSmall_
                textObject.IconZoom = MpgCustomEnum.IconZoomLevelEnum.Level3
            Else
                ' eLXgTCY
                textObject.Offset = New Point(32, 24)
                textObject.TitleFont = pointFontLarge_
                textObject.IconZoom = MpgCustomEnum.IconZoomLevelEnum.Level6
            End If

            ' Xgɒǉ
            customObjectList_.Add(textObject)

            ' ̃JX^IuWFNgID
            nextCustomID_ += 1

            Return True
        Catch
            Return False
        End Try
    End Function

    ''' <summary>
    ''' |CIuWFNgǉ
    ''' </summary>
    ''' <param name="points">oxAܓxێz</param>
    ''' <param name="pen">C`Ŏgpy</param>
    ''' <param name="brush">Cň͂܂ꂽ̈̕`ɎgpuV</param>
    ''' <returns>ꍇAtrueBȊOAfalseB</returns>
    Private Function AddPolyLine(ByVal points As PointLL(), ByVal pen As Pen, ByVal brush As Brush) As Boolean
        Try
            ' |CgȂꍇ͏I
            If points Is Nothing Or points.Length <= 0 Then
                Return True
            End If

            ' JX^IuWFNg쐬
            Dim lineObject As PolyLineObject = New PolyLineObject()
            lineObject.pen = pen
            lineObject.brush = brush
            lineObject.Points = points
            lineObject.ID = nextCustomID_.ToString()

            ' Xgɒǉ
            customObjectList_.Add(lineObject)

            ' ̃JX^IuWFNgID
            nextCustomID_ += 1

            Return True
        Catch
            Return False
        End Try

    End Function

#End Region

    '----------------------------------------------------------------------------------------------
    '	Public Methods
    '----------------------------------------------------------------------------------------------
#Region "Public Methods"

    ''' <summary>
    ''' xPʂ̌oxƈܓxPointLLIuWFNg쐬
    ''' </summary>
    ''' <returns>쐬PointLLIuWFNg</returns>
    Public Shared Function CreatePointLL(ByVal lon As String, ByVal lat As String) As PointLL
        '	ox/ܓxl̕ϊ
        Dim lonMilliSecond As Int32 = Convert.ToInt32(Convert.ToDouble(lon) * 3600000) '	ox
        Dim latMilliSecond As Int32 = Convert.ToInt32(Convert.ToDouble(lat) * 3600000) '	ܓx
        Return New PointLL(lonMilliSecond, latMilliSecond)
    End Function

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="mpgMap">MpgMapIuWFNg</param>
    Public Sub Initialize(ByVal mpgMap As MpgMap.MpgMap)
        '	MappleG Rg[̐ݒ
        mpgMap_ = mpgMap
        mpgMap_.MapRotateButton = MouseButtons.None                             ' n}̉]Ȃ
        AddHandler mpgMap_.MapButtonDown, AddressOf MpgMap_MapButtonDown

        '	n}Ɋւ郂[h̐ݒ
        MapControl = MapOperateMode.PointSelect                                 '	H_I ɐݒ

        ' J[\̐ݒ
        Using memSteam As MemoryStream = New MemoryStream(My.Resources.Grabber)
            cursorGrabber_ = New Cursor(memSteam)
        End Using

        Using memSteam As MemoryStream = New MemoryStream(My.Resources.ZoomIn)
            cursorZoomIn_ = New Cursor(memSteam)
        End Using

        Using memSteam As MemoryStream = New MemoryStream(My.Resources.ZoomOut)
            cursorZoomOut_ = New Cursor(memSteam)
        End Using

        Return
    End Sub

    ''' <summary>
    ''' n}̍XV@JX^IuWFNgf
    ''' </summary>
    Public Sub UpdateMap()
        mpgMap_.SetCustomData(customObjectList_, False)
    End Sub

    ''' <summary>
    ''' [gvZEŒZ[gvŽʂ`悷
    ''' </summary>
    ''' <param name="locs">P[Vz</param>
    ''' <param name="pnts">|Cgz</param>
    ''' <returns>`ɐꍇTrueBsꍇFalseB</returns>
    Public Function DrawDistCalcRoute(ByVal locs As DCService.Loc(), ByVal pnts As DCService.Pnt()) As Boolean
        Dim pointCount As Int32 = pnts.Length '	|Cg̎擾
        '	ő|Cg𒴂Ăꍇs
        If (pointCount > MaxLinePointCount_) Then
            Return False
        End If

        ' Wf[^쐬
        Dim points(pointCount - 1) As PointLL
        For i As Int32 = 0 To pointCount - 1
            points(i) = MapSMD.CreatePointLL(pnts(i).Lon, pnts(i).Lat)
        Next

        '	[gC̍쐬
        If Not AddPolyLine(points, routeLinePen_, Nothing) Then
            MessageBox.Show("[gC̍쐬Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If

        '	n_̍쐬
        For i As Int32 = 0 To locs.Length - 1
            '	`悷郉x쐬
            Dim labelText As String = String.Format("{0} {1:#,0} {2:#,0}m", (i + 1), locs(i).Time, locs(i).Dist)
            If Not AddText(MapSMD.CreatePointLL(locs(i).Lon, locs(i).Lat), labelText) Then
                MessageBox.Show("n_̍쐬Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return False
            End If
        Next

        ' JX^IuWFNg̔f
        UpdateMap()

        Return True
    End Function

    ''' <summary>
    ''' B / vZʂ`悷
    ''' </summary>
    ''' <param name="points">|Cg\̂̔z</param>
    ''' <param name="centerPoint">Sʒu</param>
    ''' <returns>ꍇTrueAsꍇFalse</returns>
    Public Function DrawDistCalcArea(ByVal points As SampleMG.DCService.Pnt(), ByVal centerPoint As SampleMG.DCService.NodePnt) As Boolean
        '	ő|Cg𒴂ĂȂׂ
        Dim pointCount As Int32 = points.Length                     ' |Cg̎擾
        If pointCount > MaxLinePointCount_ Then
            Return False
        End If

        '	|S̍쐬
        Dim countDelimiter As Int32 = 0                             ' ؂̃JE^
        Dim pointList As New List(Of PointLL)                       ' |S̃|Cg
        Dim currentPen As Pen = polygonLinePen_                     ' \p̃y
        Dim currentBrush As Brush = polygonBrush_                   ' \p̃uV
        For i As Int32 = 0 To pointCount - 1
            Dim lon As Double = Convert.ToDouble(points(i).Lon)     ' |Cǧox
            Dim lat As Double = Convert.ToDouble(points(i).Lat)     ' |Cǧox

            If lon = 0 AndAlso lat = 0 Then
                '	؂̏

                countDelimiter += 1

                If pointList.Count > 0 Then
                    ' |CgWꍇ
                    ' |CIuWFNg쐬
                    If Not AddPolyLine(pointList.ToArray(), currentPen, currentBrush) Then
                        '	|S̍쐬Ɏsꍇ~                            
                        Return False
                    End If
                    ' |CgWNA
                    pointList.Clear()
                End If

                If countDelimiter = 1 Then
                    '	؂肪P
                    '  ̃|S̓h[ic|S
                    currentPen = donutPolygonLinePen_
                    currentBrush = donutPolygonBrush_
                Else
                    '	؂肪P傫
                    '  ̃|S͕ʂ̃|S
                    currentPen = polygonLinePen_
                    currentBrush = polygonBrush_
                End If
            Else
                '	|Cg̏

                ' ؂JE^Oɂ
                countDelimiter = 0

                ' W|CgXgɒǉ
                pointList.Add(MapSMD.CreatePointLL(points(i).Lon, points(i).Lat))
            End If
        Next

        '	X^[gn_̍쐬
        If Not AddText(MapSMD.CreatePointLL(centerPoint.Lon, centerPoint.Lat), StartPointText_) Then
            '	n_̍쐬Ɏsꍇ
            MessageBox.Show("X^[gn_̍쐬Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If

        ' JX^IuWFNg̔f
        UpdateMap()

        Return True
    End Function

    ''' <summary>
    ''' ГꊇvZʂ`悷
    ''' </summary>
    ''' <param name="locations">P[VXg</param>
    ''' <param name="centerPoint">Sʒu</param>
    ''' <returns>ꍇTrueAsꍇFalse</returns>
    Public Function DrawDistCalcOneWay(ByVal locations As List(Of SampleMG.DCService.Loc), ByVal centerPoint As SampleMG.DCService.NodePnt) As Boolean
        '	n_̍쐬(P[Vꍇ)
        If locations.Count > 1 Then
            For i As Int32 = 0 To locations.Count - 1
                Dim labal As String = String.Format("{0} {1:#,0} {2:#,0}m", (i + 1), locations(i).Time, locations(i).Dist)  ' `悷郉x
                If Not AddText(MapSMD.CreatePointLL(locations(i).Lon, locations(i).Lat), labal) Then
                    '	n_̍쐬Ɏsꍇ
                    MessageBox.Show("n_̍쐬Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return False
                End If
            Next
        End If

        '	X^[gn_̍쐬
        If Not AddText(MapSMD.CreatePointLL(centerPoint.Lon, centerPoint.Lat), StartPointText_) Then
            '	n_̍쐬Ɏsꍇ
            MessageBox.Show("X^[gn_̍쐬Ɏs܂B", "G[", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If

        ' JX^IuWFNg̔f
        UpdateMap()

        Return True
    End Function

    ''' <summary>
    ''' n}ɒn_\
    ''' </summary>
    ''' <param name="locs">P[VXg</param>
    ''' <param name="startIndex">\郍P[V̊JnCfbNX</param>
    ''' <returns>ꍇTrueAsꍇFalse</returns>
    Public Function DrawLocRange(ByVal locs As List(Of DCService.Loc), ByVal startIndex As Int32) As Boolean
        For i As Int32 = startIndex To locs.Count - 1
            '	n_̒ǉ
            If Not AddText(MapSMD.CreatePointLL(locs(i).Lon, locs(i).Lat), (i + 1).ToString()) Then
                '	n_̍쐬ɎsĂȂH
                MessageBox.Show("n_̍쐬Ɏs܂B", "G[", _
                        MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return False
            End If
        Next

        ' JX^IuWFNg̔f
        UpdateMap()

        Return True
    End Function

    ''' <summary>
    ''' n}̒S_ݒ肷
    ''' </summary>
    ''' <param name="point">VS_</param>
    Public Sub PanMap(ByVal point As PointLL)
        If point.X > 0 AndAlso point.Y > 0 Then
            mpgMap_.MapCenter = point
            mpgMap_.RePaint()
        End If
        Return
    End Sub

    ''' <summary>
    ''' n}̃JX^IuWFNgSč폜
    ''' </summary>
    Public Sub ClearMap()
        ' JX^IuWFNgNA
        customObjectList_.Clear()
        mpgMap_.SetCustomData(customObjectList_)
        ' ̃JX^IuWFNgIDNA
        nextCustomID_ = 0
        Return
    End Sub

    ''' <summary>
    ''' ENbNn_NA
    ''' </summary>
    Public Sub ClearRightMouseButtonDownPoint()
        rightMouseButtonDownPoint_ = New PointLL(0, 0)
    End Sub

#End Region

    '----------------------------------------------------------------------------------------------
    '	Event Handlers
    '----------------------------------------------------------------------------------------------
#Region "Event Handlers"

    ''' <summary>
    ''' n}Ń}EX{^_E
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Sub MpgMap_MapButtonDown(ByVal sender As Object, ByVal e As MpgMap.Args.MapButtonDownArgs)
        Select Case e.Button
            Case MouseButtons.Left
                ' {^̏ꍇ
                ' Wۑ
                LeftMouseButtonDownPoint = e.Position
            Case MouseButtons.Right
                ' E{^̏ꍇ
                ' Wۑ
                RightMouseButtonDownPoint = e.Position
        End Select
    End Sub

#End Region

End Class
